/*
This sample shows how to use data-driven techniques
to display SAY prompts and BUTTON captions via Sub-Classing.

Tooltips are displayed in another thread.
This solution works even though it accesses a database.
*/

#include "appevent.ch"
#include "xbp.ch"
#include "fileio.ch"
#include "activex.ch"


#INCLUDE "dcdialog.CH"
#include "inksdk.ch"

#PRAGMA LIBRARY( "ASCOM10.LIB" )

FUNCTION Main()
******************************************************************
local getlist := {},cLabel := "Get content for field [Address]"
private myInkCollector,myRecognizers
private cResult := "",oResult,oSignature
DC_LoadRdds()
@ 1   ,11 dcget cLabel getsize 120 pict "@S120" editprotect {||.t.}  FONT "10.Arial Bold"

@ 2.2   ,11 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 120,10 OBJECT oSignature ID "ID_SIGNATURE" color GRA_CLR_BLACK, GraMakeRGBColor( {  30, 187, 255 } )
@ 13.5,11 dcmultiline cResult size 120,5 object oResult FONT "16.Arial Bold"

@ 2,135  dcpushbutton caption "Recognice"  size 15,2 action {||RecognizeInk(oResult),dc_getrefresh(getlist)  }
@ 5,135  dcpushbutton caption "Save"       size 15,2 action {||SaveInk()  }
@ 8,135  dcpushbutton caption "Exit"       size 15,2 action {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}
DCGETOPTIONS NORESIZE //ALWAYSONTOP NOMINBUTTON NOMAXBUTTON

dcread gui fit modal title "Ink recognizer" options getoptions  eval {||init_ink(oSignature)}
return .t.


PROCEDURE Init_Ink(oSignature)

    // Create the recognizers collection
    myRecognizers := CreateObject( "msinkaut.InkRecognizers" )

    // Create a new ink collector that uses the Frame's window
    myInkCollector      := CreateObject( "msinkaut.InkCollector" )
    //myInkCollector:hWnd := SetAppWindow():ChildFromName(ID_SIGNATURE):GetHWND()
    myInkCollector:hWnd := oSignature:GetHWND()

    // Turn the ink collector on
    myInkCollector:Enabled = .T.

RETURN


// Save strokes entered in an Ink Edit control
// to a GIF image
PROCEDURE SaveInk()

 LOCAL aBin

 altd()
    aBin := myInkCollector:Ink:Save( IPF_GIF, IPCM_Default )    // ?????

    MEMOwrit( "testfile.gif", aBin )

RETURN


// Convert strokes entered in an Ink Edit control
// to text
PROCEDURE RecognizeInk(oResult)

    // Check to ensure that the user has at least one recognizer installed
    // Note that this is a preventive check - otherwise, an exception will
    // occur during recognition
    IF 0 == myRecognizers:Count
        MsgBox( "There are no handwriting recognizers installed.  You need to have at least one in order to run this sample." )
    ELSE
        // Note that the Strokes' ToString() method is a
        // shortcut  for retrieving the best match using the
        // default recognizer.  The same result can also be
        // obtained using the RecognizerContext.
        //
    altd()
     //dc_inspectobject(myInkCollector)
        oResult:SetData( myInkCollector:Ink:Strokes:ToString() )

        // If the mouse is pressed, do not perform the recognition -
        // this prevents deleting a stroke that is still being drawn
        IF .NOT. myInkCollector:CollectingInk

            // Delete the ink from the ink collector
            myInkCollector:Ink:DeleteStrokes( myInkCollector:Ink:Strokes )

            // Force the Frame to redraw (so the deleted ink will go away)
            //SetAppWindow():InvalidateRect()
        ENDIF
    ENDIF

RETURN


// Save an array of Bytes to file
PROCEDURE SaveByteArray( cFile, aBytes )

 LOCAL nFile := FCreate( cFile, FC_NORMAL )

   IF nFile == -1
      RETURN
   ENDIF

   FWrite(nFile, aBytes, Len(aBytes))

   FClose( nFile )

RETURN


* ----------

PROC appsys ; RETURN

* ----------


